#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <eigen3/Eigen/Dense>
#include <QThread>
#include <QTimer>
#include <fstream>
#include <string>

#include <iostream>
#include <QFile>
#include <qdebug.h>
#include <QElapsedTimer>


#include <QTcpSocket>
#include <QHostAddress>
#include<QProcess>

#include<QTimer>
#include <eigen3/Eigen/Dense>
#include<limits>
#include <iostream>
#include <iomanip>
#include <vector>
#include <sstream>
#include<cstdio>
#include <QMessageBox>
using namespace  Eigen;
using namespace std;

#define ANGLE_RATIO 57.29578
using namespace std;
using namespace Eigen;
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->comboBox_resolution->setCurrentIndex(1);

    QString address = "127.0.0.1";
    QString port = "8080";
    ui->editAddress->setText(address);
    ui->editPort->setText(port);
    initServer();
}

MainWindow::~MainWindow()
{
    delete ui;
    //关闭server
    closeServer();
}


void MainWindow::on_pushButton_set_pose_clicked()
{

    QString str_x = ui->lineEdit_set_X->text();
    set_pose.x = str_x.toDouble();
    QString str_y = ui->lineEdit_set_Y->text();
    set_pose.y = str_y.toDouble();
    QString str_yaw = ui->lineEdit_set_theta->text();
    set_pose.theta = str_yaw.toDouble();
    save_setpose_file();
}

//导航模式 根据cartographer纯定位和反光住局部地图，进行定位
void MainWindow::on_pushButton_run_pose_clicked()
{
    // init pose
    int linenum = ui->comboBox_resolution->currentIndex();

    init();

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch robot_bringup robot_run_shell.launch'");

    Delay_MSec(2000);
    if(0 == linenum)//2cm
    {
        system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv_2cm.launch'");

    }
    else if(1 == linenum)//5cm
    {
        //0914 kobe
        //在目标点使用反光住模式下，cartographer中不再采用反光住做landmark，而只是做粗定位
        system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv_5cm.launch'");
    }

    //    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv.launch'");
    Delay_MSec(2000);

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; cd /home/seavo/okagv/shell/; ./startlocate.sh'");
    Delay_MSec(2000);


    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch laser_reflector_detect laser_reflector_detect_landmark_navigation_one.launch'");

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch initialpose_pub initialpose_pub.launch'");
    Delay_MSec(2000);

    QElapsedTimer overTime;
    overTime.start();

    while(!FileIsExist(okposefile))
    {
        //超出3s 跳出
        if (overTime.elapsed()>=5000)
        {
            qDebug()<<"match over time !!";
            break;
        }
    }
    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; rosnode kill /initialpose_pub'");


    if(FileIsExist(errorposefile))
    {
        //error
        qDebug()<<"match error !!";
        deletefile(errorposefile);
        return;
    }
    else if(FileIsExist(okposefile))
    {

        qDebug()<<"match ok !!";
        deletefile(okposefile);

    }

    if(FileIsExist(setposefile))
    {
        deletefile(setposefile);
    }
}



void MainWindow::on_pushButton_pubinit_clicked()
{
    pubinitpose();
}
//map的时候，不扫描反光住，只建图
void MainWindow::on_pushButton_map_clicked()
{
    int linenum = ui->comboBox_resolution->currentIndex();
    init();
    Delay_MSec(500);

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch robot_bringup robot_run_shell.launch'");
    Delay_MSec(2000);
    if(0 == linenum)//2cm
    {
        system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv_2cm.launch'");
    }
    else if(1 == linenum)//5cm
    {
        //0914 kobe
        //在目标点使用反光住模式下，cartographer中不再采用反光住做landmark，而只是做粗定位
        system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv_5cm.launch'");

    }

    Delay_MSec(1500);
    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; cd /home/seavo/okagv/shell/; ./startmap.sh'");

}

void MainWindow::on_pushButton_save_map_clicked()
{

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; cd /home/seavo/okagv/shell/; ./writestate_map.sh'");

    //2.将当前地图信息的快照保存为后缀名为.pbstream 注意必须是绝对路径，例如：/home/jac/catkin_ws/map/…
    Delay_MSec(8000);
    //3.通过cartographer提供的ros包，将后缀名为.pbstream的地图信息，转化成ros地图信息

    //0.05
    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; rosrun cartographer_ros cartographer_pbstream_to_ros_map -map_filestem=/home/kobe/okagv/map/map -pbstream_filename=/home/kobe/okagv/map/map.pbstream -resolution=0.05'");
    //o.o2
    //    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; rosrun cartographer_ros cartographer_pbstream_to_ros_map -map_filestem=/home/kobe/okagv/map/map -pbstream_filename=/home/kobe/okagv/map/map.pbstream -resolution=0.02'");

    Delay_MSec(5000);
    killmapnode();

}


void MainWindow::pubinitpose(void)
{
    system("gnome-terminal -- bash -c 'source /home/kobe/mynew_ws/install_isolated/setup.bash; roslaunch initialpose_pub initialpose_pub.launch'");
}


void MainWindow::save_setpose_file(void)
{
    double theta_hudu = set_pose.theta/ANGLE_RATIO ;
    AngleAxisd rollAngle(AngleAxisd(0,Vector3d::UnitX()));
    AngleAxisd pitchAngle(AngleAxisd(0,Vector3d::UnitY()));
    AngleAxisd yawAngle(AngleAxisd(theta_hudu,Vector3d::UnitZ()));

    Quaterniond quaternion;
    quaternion=yawAngle*pitchAngle*rollAngle;

    string strlist[7];
    strlist[0] = (QString::number(set_pose.x, 'f', 3)).toStdString();
    strlist[1] = (QString::number(set_pose.y, 'f', 3)).toStdString();
    strlist[2] = (QString::number(0, 'f', 3)).toStdString();
    strlist[3] = (QString::number(quaternion.x(), 'f', 3)).toStdString();
    strlist[4] = (QString::number(quaternion.y(), 'f', 3)).toStdString();
    strlist[5] = (QString::number(quaternion.z(), 'f', 3)).toStdString();
    strlist[6] = (QString::number(quaternion.w(), 'f', 3)).toStdString();

    std::ofstream outFile1;
    //  //把数值型转换为字符串型
    std::string image_time_="setfile.csv";

    char const*url_v1 = "/home/kobe/okagv/files/";
    std::string const& cc = std::string(url_v1) + image_time_;
    char const*ch = cc.c_str();

    outFile1.open(ch);
    for(int i = 0;i<7;i++)
    {
        outFile1<<strlist[i]<<",";
    }

    outFile1<<"\n";

    outFile1.close();

}




void MainWindow::killmapnode(void)
{
    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; rosnode kill -a'");
    Delay_MSec(1000);
    system("gnome-terminal -- bash -c 'ps aux | grep rosout |  awk '{print $2}' | xargs kill -9; ps aux | grep rviz |  awk '{print $2}' | xargs kill -9'");
    Delay_MSec(1000);
}

//文件是否存在
bool MainWindow::FileIsExist(QString strFile)
{
    QFile tempFile(strFile);
    return tempFile.exists();
}

bool MainWindow::deletefile(QString strFile)
{
    QFile file(strFile);
    bool ok = file.remove();
    //删除成功返回true，失败返回false
    return ok;
}


//延迟函数
void MainWindow::Delay_MSec(unsigned int msec)
{
    QEventLoop loop;//定义一个新的事件循环
    QTimer::singleShot(msec, &loop, SLOT(quit()));//创建单次定时器，槽函数为事件循环的退出函数
    loop.exec();//事件循环开始执行，程序会卡在这里，直到定时时间到，本循环被退出
}

void MainWindow::init(void)
{
    //
    QProcess::startDetached("/home/seavo/okagv/shell/init.sh");
    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; cd /home/seavo/okagv/shell/; ./init.sh'");
    Delay_MSec(200);
}

void MainWindow::on_pushButton_stop_locate_clicked()
{
    killmapnode();
    Delay_MSec(2000);
}

void MainWindow::on_pushButton_stop_map_clicked()
{
    killmapnode();
}

/*********************************************************************/
/*功能：拷贝文件夹
    qCopyDirectory -- 拷贝目录
    fromDir : 源目录
    toDir   : 目标目录
    bCoverIfFileExists : ture:同名时覆盖  false:同名时返回false,终止拷贝
    返回: ture拷贝成功 false:拷贝未完成*/
/***********************************************************************/
bool MainWindow::qCopyDirectory(const QDir& fromDir, const QDir& toDir, bool bCoverIfFileExists)
{
    QDir formDir_ = fromDir;
    QDir toDir_ = toDir;

    if(!toDir_.exists())
    {
        if(!toDir_.mkdir(toDir.absolutePath()))
            return false;
    }

    QFileInfoList fileInfoList = formDir_.entryInfoList();
    foreach(QFileInfo fileInfo, fileInfoList)
    {
        if(fileInfo.fileName() == "." || fileInfo.fileName() == "..")
            continue;

        //拷贝子目录
        if(fileInfo.isDir())
        {
            //递归调用拷贝
            if(!qCopyDirectory(fileInfo.filePath(), toDir_.filePath(fileInfo.fileName()),true))
                return false;
        }
        //拷贝子文件
        else
        {
            if(bCoverIfFileExists && toDir_.exists(fileInfo.fileName()))
            {
                toDir_.remove(fileInfo.fileName());
            }
            if(!QFile::copy(fileInfo.filePath(), toDir_.filePath(fileInfo.fileName())))
            {
                return false;
            }
        }
    }
    return true;
}
void MainWindow::on_pushButton_setMapfolder_clicked()
{
    mapfolder_name = ui->lineEdit_setMapfolder->text();

}

void MainWindow::on_pushButton_Map_backup_clicked()
{
    if((mapfolder_name == "null")||(mapfolder_name == ""))
     {
        QMessageBox::critical(this,tr("Warning"),tr("File name not set !"));
        return;
     }

    //将模板中的stl和spro文件复制到新创建的文件夹中
    //默认文件选择路径为，程序所在的路径
    QString mapfromDir = "/home/kobe/okagv/map/"; //获取模板路径
    QDir  fromDir(mapfromDir);  //实例化这个路径对象

    QString maptoDir = mapfolderpath + mapfolder_name; //获取目标文件夹路径
    QDir  toDir(maptoDir);//实例化目标文件夹路径对象
    bool a =  qCopyDirectory(fromDir, toDir, true); //拷贝模板下的stl文件和spro文件到新工程下
    qDebug() << "a = "<< a; //执行成功返回true
}

/********************************************************************************
说明：删除文件及文件夹涉及到的类包括QDir、QFile、QFileInfo、QFileInfoList，
      清空文件夹的方法很多，此处仅给出我常用的两种方法
*********************************************************************************/

/********************************************************************************
clearFiles():仅清空文件夹内的文件(不包括子文件夹内的文件)
folderFullPath:文件夹全路径
*********************************************************************************/
void MainWindow::clearFiles(const QString &folderFullPath)
{
    QDir dir(folderFullPath);
    dir.setFilter(QDir::Files);
    int fileCount = dir.count();
    for (int i = 0; i < fileCount; i++)
        dir.remove(dir[i]);
}

/********************************************************************************
clearFolder():删除非空文件夹
folderFullPath:文件夹全路径
*********************************************************************************/
void MainWindow::clearFolder(const QString &folderFullPath)
{

    QDir             dir(folderFullPath);
    QFileInfoList    fileList;
    QFileInfo        curFile;
    QFileInfoList    fileListTemp;
    int            infoNum;
    int            i;
    int            j;
    /* 首先获取目标文件夹内所有文件及文件夹信息 */
    fileList=dir.entryInfoList(QDir::Dirs|QDir::Files
                               |QDir::Readable|QDir::Writable
                               |QDir::Hidden|QDir::NoDotAndDotDot
                               ,QDir::Name);

    while(fileList.size() > 0)
    {
        infoNum = fileList.size();

        for(i = infoNum - 1; i >= 0; i--)
        {
            curFile = fileList[i];
            if(curFile.isFile()) /* 如果是文件，删除文件 */
            {
                QFile fileTemp(curFile.filePath());
                fileTemp.remove();
                fileList.removeAt(i);
            }

            if(curFile.isDir()) /* 如果是文件夹 */
            {
                QDir dirTemp(curFile.filePath());
                fileListTemp = dirTemp.entryInfoList(QDir::Dirs | QDir::Files
                                                     | QDir::Readable | QDir::Writable
                                                     | QDir::Hidden | QDir::NoDotAndDotDot
                                                     , QDir::Name);
                if(fileListTemp.size() == 0) /* 下层没有文件或文件夹 则直接删除*/
                {
                    dirTemp.rmdir(".");
                    fileList.removeAt(i);
                }
                else /* 下层有文件夹或文件 则将信息添加到列表*/
                {
                    for(j = 0; j < fileListTemp.size(); j++)
                    {
                        if(!(fileList.contains(fileListTemp[j])))
                        {
                            fileList.append(fileListTemp[j]);
                        }
                    }
                }
            }
        }
    }
    dir.rmdir(".");/*删除目标文件夹,如果只是清空文件夹folderFullPath的内容而不删除folderFullPath本身,则删掉本行即可*/
}



//对字符串进行拆分
vector<string> split(const string& str, const string& delim) {
    vector<string> res;
    char *next_token = NULL;
    if ("" == str) return res;
    //先将要切割的字符串从string类型转换为char*类型
    char * strs = new char[str.length() + 1]; //不要忘了

    strcpy(strs,str.c_str());
    char * d = new char[delim.length() + 1];
    strcpy(d,delim.c_str());

    char *p = strtok_r(strs, d,&next_token);
    while (p)
    {
        string s = p; //分割得到的字符串转换为string类型
        res.push_back(s); //存入结果数组
        p = strtok_r(NULL, d, &next_token);
    }
    return res;
}


void MainWindow::dataprogess(QString getstr)
{
    char getcode[100];
    strcpy(getcode,getstr.toStdString().c_str());//,strlen(getstr.length()));

    char set[5] = "get,";
    string get_str;

    get_str.replace(0, 50, getcode);

    std::vector<string> res = split(get_str, ",");
    float databuf[10];
    if(0 == strncmp(set,res.at(0).c_str(),3))
    {
        printf("getget: %s\n", getcode);

        for (int i = 0; i < res.size(); ++i)
        {
            databuf[i] =  atof(res[i].data());
            cout << databuf[i] << endl;
        }
    }

}
void MainWindow::initServer()
{
    //创建Server对象
    server = new QTcpServer(this);
    //开始监听
    //判断当前是否已开启，是则close，否则listen
    if(server->isListening())
    {
        closeServer();
        //关闭server后恢复界面状态
        ui->btnListen->setText("Listen");
        ui->editAddress->setEnabled(true);
        ui->editPort->setEnabled(true);
    }
    else
    {
        //从界面上读取ip和端口
        //可以使用 QHostAddress::Any 监听所有地址的对应端口
        const QString address_text=ui->editAddress->text();
        const QHostAddress address=(address_text=="Any")
                ?QHostAddress::Any
               :QHostAddress(address_text);
        const unsigned short port=ui->editPort->text().toUShort();
        //开始监听，并判断是否成功
        if(server->listen(address,port)){
            //连接成功就修改界面按钮提示，以及地址栏不可编辑
            ui->btnListen->setText("Close");
            ui->editAddress->setEnabled(false);
            ui->editPort->setEnabled(false);
        }
    }
    updateState();

    //监听到新的客户端连接请求
    connect(server,&QTcpServer::newConnection,this,[this]{
        //如果有新的连接就取出
        while(server->hasPendingConnections())
        {
            //nextPendingConnection返回下一个挂起的连接作为已连接的QTcpSocket对象
            //套接字是作为服务器的子级创建的，这意味着销毁QTcpServer对象时会自动删除该套接字。
            //最好在完成处理后显式删除该对象，以避免浪费内存。
            //返回的QTcpSocket对象不能从另一个线程使用，如有需要可重写incomingConnection().
            QTcpSocket *socket=server->nextPendingConnection();
            clientList.append(socket);
            ui->textRecv->append(QString("[%1:%2] Soket Connected")
                                 .arg(socket->peerAddress().toString())
                                 .arg(socket->peerPort()));

            //关联相关操作的信号槽
            //收到数据，触发readyRead
            connect(socket,&QTcpSocket::readyRead,[this,socket]
            {
                //没有可读的数据就返回
                if(socket->bytesAvailable()<=0)
                    return;
                //注意收发两端文本要使用对应的编解码
                const QString recv_text=QString::fromUtf8(socket->readAll());
                ui->textRecv->append(QString("[%1:%2]")
                                     .arg(socket->peerAddress().toString())
                                     .arg(socket->peerPort()));
                ui->textRecv->append(recv_text);

                //get pose str
                getposestr = recv_text;

            });

            //error信号在5.15换了名字
#if QT_VERSION < QT_VERSION_CHECK(5, 15, 0)
            //错误信息
            connect(socket, static_cast<void(QAbstractSocket::*)(QAbstractSocket::SocketError)>(&QAbstractSocket::error),
                    [this,socket](QAbstractSocket::SocketError){
                ui->textRecv->append(QString("[%1:%2] Soket Error:%3")
                                     .arg(socket->peerAddress().toString())
                                     .arg(socket->peerPort())
                                     .arg(socket->errorString()));
            });
#else
            //错误信息
            connect(socket,&QAbstractSocket::errorOccurred,[this,socket](QAbstractSocket::SocketError){
                ui->textRecv->append(QString("[%1:%2] Soket Error:%3")
                                     .arg(socket->peerAddress().toString())
                                     .arg(socket->peerPort())
                                     .arg(socket->errorString()));
            });
#endif

            //连接断开，销毁socket对象，这是为了开关server时socket正确释放
            connect(socket,&QTcpSocket::disconnected,[this,socket]{
                socket->deleteLater();
                clientList.removeOne(socket);
                ui->textRecv->append(QString("[%1:%2] Soket Disonnected")
                                     .arg(socket->peerAddress().toString())
                                     .arg(socket->peerPort()));
                updateState();
            });
        }
        updateState();
    });

    //server向client发送内容
    connect(ui->pushButton_set_route,&QPushButton::clicked,[this]
    {
        //        //判断是否开启了server
        //        if(!server->isListening())
        //            return;
        //        //将发送区文本发送给客户端
        //        const QByteArray send_data=ui->textSend->toPlainText().toUtf8();
        //        //数据为空就返回
        //        if(send_data.isEmpty())
        //            return;
        //        for(QTcpSocket *socket:clientList)
        //        {
        //            socket->write(send_data);
        //            //socket->waitForBytesWritten();
        //        }
    });

    //server的错误信息
    //如果发生错误，则serverError()返回错误的类型，
    //并且可以调用errorString()以获取对所发生事件的易于理解的描述
    connect(server,&QTcpServer::acceptError,[this](QAbstractSocket::SocketError){
        ui->textRecv->append("Server Error:"+server->errorString());
    });
}

void MainWindow::closeServer()
{
    //停止服务
    server->close();
    for(QTcpSocket * socket:clientList)
    {
        //断开与客户端的连接
        socket->disconnectFromHost();
        if(socket->state()!=QAbstractSocket::UnconnectedState){
            socket->abort();
        }
    }
}

void MainWindow::updateState()
{
    //将当前server地址和端口、客户端连接数写在标题栏
    if(server->isListening()){
        setWindowTitle(QString("Server[%1:%2] connections:%3")
                       .arg(server->serverAddress().toString())
                       .arg(server->serverPort())
                       .arg(clientList.count()));
    }else{
        setWindowTitle("Server");
    }
}

void MainWindow::on_pushButton_set_route_clicked()
{
    QString qstr_set_num = ui->lineEdit_set_num->text();

    string tmp_str;

    tmp_str = qstr_set_num.toStdString();

    all_str = "set,";
    all_str = all_str + tmp_str +",";

    //判断是否开启了server
    if(!server->isListening())
    {
        all_str.clear();
        return;
    }

    qDebug()<< QString::fromStdString(all_str);

    QString qstr = QString::fromStdString(all_str);
    QByteArray all_bytes = qstr.toLatin1();  // QString转QByteArray方法2

    //将发送区文本发送给客户端
    //数据为空就返回
    if(all_bytes.isEmpty())
        return;

    for(QTcpSocket *socket:clientList)
    {
        socket->write(all_bytes);
    }

    all_str.clear();
}

void MainWindow::on_pushButton_go_route_clicked()
{
    QString qstr_set_num = ui->lineEdit_go_num->text();
    string tmp_str;
    tmp_str = qstr_set_num.toStdString();
    all_str = "go,";

    all_str = all_str + tmp_str +",";

    //判断是否开启了server
    if(!server->isListening())
    {
        all_str.clear();
        return;
    }

    qDebug()<< QString::fromStdString(all_str);

    QString qstr = QString::fromStdString(all_str);
    QByteArray all_bytes = qstr.toLatin1();  // QString转QByteArray方法2

    //将发送区文本发送给客户端
    //数据为空就返回
    if(all_bytes.isEmpty())
        return;

    for(QTcpSocket *socket:clientList)
    {
        socket->write(all_bytes);
    }

    all_str.clear();
}

void MainWindow::on_pushButton_clear_clicked()
{
    ui->textRecv->clear();
}

void MainWindow::on_pushButton_save_csv_clicked()
{
    QString qstr_set_num = ui->lineEdit_set_num->text();
    string tmp_str;
    tmp_str = qstr_set_num.toStdString();

    all_str = "save,";

    //判断是否开启了server
    if(!server->isListening())
    {
        all_str.clear();
        return;
    }

    qDebug()<< QString::fromStdString(all_str);

    QString qstr = QString::fromStdString(all_str);
    QByteArray all_bytes = qstr.toLatin1();  // QString转QByteArray方法2

    //将发送区文本发送给客户端
    //数据为空就返回
    if(all_bytes.isEmpty())
        return;

    for(QTcpSocket *socket:clientList)
    {
        socket->write(all_bytes);
    }

    all_str.clear();
}
//建图完成后，扫描单根反光住，上位机发送路径和添加反光住指令，保持反光住文件
void MainWindow::on_pushButton_add_reflector_clicked()
{
    // init pose
    int linenum = ui->comboBox_resolution->currentIndex();
    //    bool status =ui->checkBox_reflector->isChecked();
    //    int mode = ui->comboBox_landmark_mode->currentIndex();

    init();

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch robot_bringup robot_run_shell.launch'");

    Delay_MSec(2000);
    if(0 == linenum)//2cm
    {
        system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv_2cm.launch'");
    }
    else if(1 == linenum)//5cm
    {
        //0914 kobe
        //在目标点使用反光住模式下，cartographer中不再采用反光住做landmark，而只是做粗定位
        system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv_5cm.launch'");
    }

    //    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch cartographer_ros backpack_2d_peak_okagv.launch'");
    Delay_MSec(2000);

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; cd /home/seavo/okagv/shell/; ./startlocate.sh'");
    Delay_MSec(2000);

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch laser_reflector_detect laser_reflector_detect_landmark_slam_one.launch'");

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; roslaunch initialpose_pub initialpose_pub.launch'");
    Delay_MSec(2000);

    QElapsedTimer overTime;
    overTime.start();

    while(!FileIsExist(okposefile))
    {
        //超出3s 跳出
        if (overTime.elapsed()>=5000)
        {
            qDebug()<<"match over time !!";
            break;
        }
    }

    system("gnome-terminal -- bash -c 'source /home/seavo/yfagv_ws/install_isolated/setup.bash; rosnode kill /initialpose_pub'");


    if(FileIsExist(errorposefile))
    {
        //error
        qDebug()<<"match error !!";
        deletefile(errorposefile);
        return;
    }
    else if(FileIsExist(okposefile))
    {

        qDebug()<<"match ok !!";
        deletefile(okposefile);

    }

    if(FileIsExist(setposefile))
    {
        deletefile(setposefile);
    }
}

void MainWindow::on_pushButton_SetLoadFolder_clicked()
{
    loadmapfolder_name = ui->lineEdit_loadMapfolder->text();
}

void MainWindow::on_pushButton_loadMapfolder_clicked()
{
    if((loadmapfolder_name == "null")||(loadmapfolder_name == ""))
    {
       QMessageBox::critical(this,tr("Warning"),tr("File name not set !"));
       return;
    }
    QString goal_map_folder = "/home/kobe/okagv/map";
    clearFolder(goal_map_folder);

    //将模板中的stl和spro文件复制到新创建的文件夹中
    //默认文件选择路径为，程序所在的路径
    QString mapfromDir =  mapfolderpath + loadmapfolder_name; //获取模板路径
    QDir  fromDir(mapfromDir);  //实例化这个路径对象

    QString maptoDir ="/home/kobe/okagv/map/"; //获取目标文件夹路径
    QDir  toDir(maptoDir);//实例化目标文件夹路径对象
    bool a =  qCopyDirectory(fromDir, toDir, true); //拷贝模板下的stl文件和spro文件到新工程下
    qDebug() << "load ok?"<< a; //执行成功返回true

}
