#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

#include <QDir>
#include <QFileInfoList>
#include <QMainWindow>
#include <QWidget>
#include <QTcpServer>
#include <QTcpSocket>
namespace Ui {
class MainWindow;
}
//一个 pose 点
struct posvalue
{
    double x;
    double y;
    double theta;
};
class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    //void on_pushButton_pose_clicked();
    void Delay_MSec(unsigned int);

    void on_pushButton_set_pose_clicked();

    void on_pushButton_run_pose_clicked();
    void save_setpose_file();
    bool FileIsExist(QString);
    //    void killgetnode(void);
    void killmapnode(void);
    void init(void);

    //    void startlocate();
    bool deletefile(QString);
    //void on_pushButton_locate_clicked();

    void on_pushButton_pubinit_clicked();
    void pubinitpose();
    void on_pushButton_map_clicked();

    void on_pushButton_save_map_clicked();

    void on_pushButton_stop_locate_clicked();

    void on_pushButton_stop_map_clicked();

    void on_pushButton_setMapfolder_clicked();
    bool qCopyDirectory(const QDir&, const QDir&, bool);

    void on_pushButton_Map_backup_clicked();

    //void on_pushButton_set_loadMapfolder_clicked();
    void clearFiles(const QString &);


    void clearFolder(const QString &);
    //---sever about
    //初始化server操作
    void initServer();
    //close server
    void closeServer();
    //更新当前状态
    void updateState();
    void  dataprogess(QString getstr);


    void on_pushButton_set_route_clicked();

    void on_pushButton_go_route_clicked();

    void on_pushButton_clear_clicked();

    void on_pushButton_save_csv_clicked();

    void on_pushButton_add_reflector_clicked();

    void on_pushButton_SetLoadFolder_clicked();

    void on_pushButton_loadMapfolder_clicked();

private:
    Ui::MainWindow *ui;
    posvalue set_pose;
    posvalue  get_pose;

    QString setposefile = "/home/kobe/okagv/files/setfile.csv";

    QString errorposefile = "/home/kobe/okagv/files/matcherror.csv";

    QString okposefile = "/home/kobe/okagv/files/matchok.csv";

    //------------
    QString mapfolderpath = "/home/kobe/okagv/map_backup_folders/";
    QString mapfolder_name = "default";

    QString loadmapfolder_name = "default";


    //about socket
    //server用于监听端口，获取新的tcp连接的描述符
    QTcpServer *server;
    //存储已连接的socket对象
    QList<QTcpSocket*> clientList;
    std::string all_str;
    QString getposestr;
};

#endif // MAINWINDOW_H
